package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.annotation.JsonUnwrapped;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import io.accumulatenetwork.sdk.protocol.Account;
import io.accumulatenetwork.sdk.protocol.Url;
import io.accumulatenetwork.sdk.support.Marshaller;
import io.accumulatenetwork.sdk.support.serializers.GoBigIntDeserializer;
import io.accumulatenetwork.sdk.support.serializers.GoBigIntSerializer;
// UnionType: AccountType
// UnionValue: TokenIssuer

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("TokenIssuer")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class TokenIssuer implements Account {
	public final AccountType type = AccountType.TOKEN_ISSUER;
	private Url url;
	@JsonUnwrapped
	private AccountAuth accountAuth;
	private String symbol;
	private long precision;
	private Url properties;
	private java.math.BigInteger issued;
	private java.math.BigInteger supplyLimit;

    //
	public Url getUrl() {
	    return url;
	}
	public void setUrl(final Url value) {
	    this.url = value;
	}

	public TokenIssuer url(final Url value) {
	    setUrl(value);
	    return this;
	}
	public TokenIssuer url(final String value) {
	    setUrl(Url.toAccURL(value));
	    return this;
	}
	public AccountAuth getAccountAuth() {
	    return accountAuth;
	}
	public void setAccountAuth(final AccountAuth value) {
	    this.accountAuth = value;
	}

	public TokenIssuer accountAuth(final AccountAuth value) {
	    setAccountAuth(value);
	    return this;
	}
	public String getSymbol() {
	    return symbol;
	}
	public void setSymbol(final String value) {
	    this.symbol = value;
	}

	public TokenIssuer symbol(final String value) {
	    setSymbol(value);
	    return this;
	}
	public long getPrecision() {
	    return precision;
	}
	public void setPrecision(final long value) {
	    this.precision = value;
	}

	public TokenIssuer precision(final long value) {
	    setPrecision(value);
	    return this;
	}
	public Url getProperties() {
	    return properties;
	}
	public void setProperties(final Url value) {
	    this.properties = value;
	}

	public TokenIssuer properties(final Url value) {
	    setProperties(value);
	    return this;
	}
	public TokenIssuer properties(final String value) {
	    setProperties(Url.toAccURL(value));
	    return this;
	}
	@JsonDeserialize(using = GoBigIntDeserializer.class)
	public java.math.BigInteger getIssued() {
	    return issued;
	}
	@JsonSerialize(using = GoBigIntSerializer.class)
	public void setIssued(final java.math.BigInteger value) {
	    this.issued = value;
	}

	public TokenIssuer issued(final java.math.BigInteger value) {
	    setIssued(value);
	    return this;
	}
	@JsonDeserialize(using = GoBigIntDeserializer.class)
	public java.math.BigInteger getSupplyLimit() {
	    return supplyLimit;
	}
	@JsonSerialize(using = GoBigIntSerializer.class)
	public void setSupplyLimit(final java.math.BigInteger value) {
	    this.supplyLimit = value;
	}

	public TokenIssuer supplyLimit(final java.math.BigInteger value) {
	    setSupplyLimit(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        marshaller.writeValue(1, type);
        if (!(this.url == null)) {
            marshaller.writeUrl(2, this.url);
        }
        if (!(this.accountAuth == null)) {
            marshaller.writeValue(3, accountAuth);
        }
        if (!(this.symbol == null || this.symbol.length() == 0)) {
            marshaller.writeString(4, this.symbol);
        }
        if (!(this.precision == 0)) {
            marshaller.writeUint(5, this.precision);
        }
        if (!(this.properties == null)) {
            marshaller.writeUrl(6, this.properties);
        }
        if (!((this.issued).equals(java.math.BigInteger.ZERO))) {
            marshaller.writeBigInt(7, this.issued);
        }
        if (!((this.supplyLimit).equals(java.math.BigInteger.ZERO))) {
            marshaller.writeBigInt(8, this.supplyLimit);
        }
        return marshaller.array();
    }
}
